// main.cpp     ***Baidariu nuoma***
#include <iostream>
#include <iomanip>
#include <vector>
#include <climits>
#include <fstream>
using namespace std;
//------------------------------------------------------------------------------
struct Canoe
{
    int       capacity;    // vietu skaicius
    int       regNumber;  // registracijos numeris
        int       maxWeight;  // maksimalus svoris baidareje
    int       year;       // pagaminimo metai
    string    model;     // Baidares tolimoms kelionems,Iprastos baidares ir panasiai...
    int       hourPrice; // valnos kaina
    int       dayPrice;   // dienos kaina
    int       rentedByCustomer;  // numeruosime nuo 1
    int       moneyEarned;   // uzdirbti pinigai
    int       rentedTimes;   // kiek kartu isnuomuota

};
typedef vector<Canoe> Canoes;
//------------------------------------------------------------------------------
struct Customer
{
    string    name;        // vardas
    string    surename;    // pavarde
    string    address;     //kliento adresas
        long long telephone;   //Telefono numeris
    long long code;        //Asmens kodas
    long long moneyEarned; // pinigai
    long long timesRented; // skaicius kiek buvo isnuomaves baidariu
    int       weight;      // zmogaus svoris
};
typedef vector<Customer> Customers;
//------------------------------------------------------------------------------
void printMenuCustomer (Canoes& canoes, Customers& customers);
void printMenuCanoe    (      Canoes&     canoes);
void printMenuRent     (      Canoes&     canoes);
void printMenu         ();
void print_Canoes      (const Canoes&     canoes, int i);
void printCanoes       (const Canoes&     canoes);
void printCustomers    (const Customers&  customers);
void print_Customers   (const Customers&  customers, int i);
void addCanoe          (      Canoes&     canoes);
void addCustomer       (      Customers&  customers);
void rentCanoe         (      Canoes&     canoes, Customers& customers);
void returnCanoe       (      Canoes&     canoes);
void freeCanoes        (      Canoes&     canoes);
void rentedCanoes      (      Canoes&     canoes);
void popularCanoe      (      Canoes&     canoes);
void maxEarnedCanoe    (      Canoes&     canoes);
void maxEarnedCustomer (      Customers&  customers);
void CustomerRented    (const Canoes&     canoes, const Customers& customers);
void saveData          (      Canoes&     canoes,       Customers& customers);
void loadData          (      Canoes&     canoes,       Customers& customers);
//------------------------------------------------------------------------------
void printMenuCanoe    (Canoes& canoes)
{
     for (;;)
               {
                   cout << endl
                        << " ****************************************"  << endl
                        << " *  1 - Prideti nauja baidare           *" << endl
                        << " *  2 - Spausdinti baidares             *" << endl
                        << " *  3 - Populiariausi baidare           *" << endl
                        << " *  4 - Rodyti laisvas baidares         *" << endl
                        << " *  5 - Rodyti isnuomuotas baidares     *" << endl
                        << " *  6 - Daugiausiai uzdirbanti baidare  *" << endl
                        << " ****************************************" << endl
                        << " *  7 - Pagrindinis meniu               *" << endl
                                << " ****************************************" <<endl
                        << " :>";



                    string key;
                    cin >> key;
                             if (key == "1") addCanoe        (canoes);
                        else if (key == "2") printCanoes     (canoes);
                        else if (key == "3") popularCanoe    (canoes);
                        else if (key == "4") freeCanoes      (canoes);
                        else if (key == "5") rentedCanoes    (canoes);
                        else if (key == "6") maxEarnedCanoe  (canoes);
                        else if (key == "7") return;
                        else cout << "neteisinga komanda" << endl;
               }
}
//------------------------------------------------------------------------------
void printMenuCustomer (Canoes& canoes, Customers& customers)
{
     for (;;)
               {
                   cout << endl
                        << " ************************************" << endl
                        << " *  1 - Prideti nauja klienta       *" << endl
                        << " *  2 - Spausdinti klientus         *" << endl
                        << " *  3 - Naudingiausias klientas     *" << endl
                        << " *  4 - Klientas yra issinuomaves   *" << endl
                        << " ************************************" << endl
                        << " *  5 - Pagrindinis meniu           *" << endl
                        << " ************************************" << endl
                        << " :>";


                    string key;
                    cin >> key;
                             if (key == "1") addCustomer        (customers);
                        else if (key == "2") printCustomers     (customers);
                        else if (key == "3") maxEarnedCustomer  (customers);
                        else if (key == "4") CustomerRented     (canoes, customers);
                        else if (key == "5") return;
                        else cout << "neteisinga komanda" << endl;
               }
}
//------------------------------------------------------------------------------
void printMenuRent (Canoes& canoes, Customers& customers)
{
     for (;;)
               {
                   cout << endl
                        << " ************************************" << endl
                        << " * 1 - Isnuomuoti klientuj baidare  *" << endl
                        << " * 2 - Grazinti baidare             *" << endl
                        << " ************************************" << endl
                        << " * 3 - Pagrindinis meniu            *" << endl
                        << " ************************************" << endl
                        << " :>";


                    string key;
                    cin >> key;
                             if (key == "1") rentCanoe (canoes, customers);
                        else if (key == "2") returnCanoe (canoes);
                        else if (key == "3") return;
                        else cout << "neteisinga komanda" << endl;
               }
}
//------------------------------------------------------------------------------
void printMenu ()
{
    cout << endl
         << endl
         << endl
         << " *****************************************" << endl
         << " * Baidariu nuoma:                       *" << endl
         << " *  1  - Spausdinti baidares             *" << endl
         << " *  2  - Prideti nauja baidare           *" << endl
         << " *  3  - Populiariausi baidare           *" << endl
                 << " *  4  - Rodyti laisvas baidares         *" << endl
                 << " *  5  - Rodyti isnuomotas baidares      *" << endl
                 << " *  6  - Daugiausiai uzdirbanti baidare  *" << endl
                 << " *****************************************" << endl
                 << " *  7  - Spausdinti klientus             *" << endl
                 << " *  8  - Prideti nauja klienta           *" << endl
                 << " *  9  - Naudingiausias klientas         *" << endl
                 << " *  10 - Klientas yra issinuomaves       *" << endl
                 << " *****************************************" << endl
                 << " *  11 - Isnuomuoti klientui             *" << endl
         << " *  12 - Baidare grazinta                *" << endl
         << " *****************************************" << endl
         << " *  0  - Baigti darba                    *" << endl
                 << " *****************************************" << endl;
}
//------------------------------------------------------------------------------
int main ()
{

    Canoes     canoes;
    Customers  customers;
    loadData(canoes, customers);
    for (;;)
    {
        cout << endl;
        cout << "     ><><><><><><><><><><><><><>< "<< endl
             << "     >< m - pagrindinis meniu  >< "<< endl
             << "     >< k - kliento meniu      >< "<< endl
             << "     >< b - baidariu meniu     >< "<< endl
             << "     >< n - nuomos meniu       >< "<< endl
             << "     ><><><><><><><><><><><><><>< "<< endl
             << endl
             << " :>";
        string key;
        cin >> key;
        if (key == "0") break;
        else if (key == "n")   printMenuRent     (canoes, customers);
        else if (key == "b")   printMenuCanoe    (canoes);
        else if (key == "k")   printMenuCustomer (canoes, customers);
        else if (key == "m")   printMenu         ();
        else if (key == "1")   printCanoes       (canoes);
        else if (key == "2")   addCanoe          (canoes);
        else if (key == "3")   popularCanoe      (canoes);
                else if (key == "4")   freeCanoes        (canoes);
                else if (key == "5")   rentedCanoes      (canoes);
                else if (key == "6")   maxEarnedCanoe    (canoes);
                else if (key == "7")   printCustomers    (customers);
                else if (key == "8")   addCustomer       (customers);
                else if (key == "9")   maxEarnedCustomer (customers);
                else if (key == "10")  CustomerRented    (canoes, customers);
                else if (key == "11")  rentCanoe         (canoes, customers);
        else if (key == "12")  returnCanoe       (canoes);
        else cout << endl << "Neteisinga komanda..." << endl;
    }
    saveData    (canoes, customers);
}
//------------------------------------------------------------------------------
void print_Canoes      (const Canoes&     canoes, int i)
{
    cout  <<"__________________________________________________________________________"
          << endl
          << (i+1)
          << ".   "         << canoes[i].rentedByCustomer
          << "\t  "         << canoes[i].maxWeight       << " kg"
          << "\t  "         << canoes[i].year            << " metu"
          << "\t  "         << canoes[i].hourPrice       << " Lt/h"
          << "\t  "         << canoes[i].dayPrice        << " Lt/d"
          << " ("           << canoes[i].moneyEarned     << " Lt)"
          << "\t\t     Nr." << canoes[i].regNumber
          << "\t\t"       << canoes[i].model
          << "\t\t"       << canoes[i].capacity        << " viete"
          << "\t"         << canoes[i].rentedTimes     << " kartus"
          <<endl
          <<"__________________________________________________________________________"
          << endl;

}
//------------------------------------------------------------------------------
void printCanoes    (const Canoes&    canoes)
{

    cout << "Baidariu kiekis: " << canoes.size() << endl;

         for (int i = 0;  i < canoes.size();  i++)
        {
            print_Canoes(canoes, i );
                }

}
//------------------------------------------------------------------------------
void maxEarnedCustomer (Customers&  customers)
{
    int thebest = 0;

            for (int i = 0; i < customers.size(); i++)
                    {
                            if (customers[i].moneyEarned >= thebest)
                                thebest = customers[i].moneyEarned;
                        }
                for (int i = 0; i < customers.size(); i++)
        {
            if (customers[i].moneyEarned == thebest)
                        {
                            cout << "Daugiausiai uzdirbanti baidare: " <<  endl;
                        print_Customers(customers, i);
                        }
        }
}
//------------------------------------------------------------------------------
void maxEarnedCanoe    (Canoes& canoes)
{
    int thebest = 0;

            for (int i = 0; i < canoes.size(); i++)
                    {
                            if (canoes[i].moneyEarned >= thebest)
                                thebest = canoes[i].moneyEarned;
                        }
                for (int i = 0; i < canoes.size(); i++)
        {
            if (canoes[i].moneyEarned == thebest)
                        {
                            cout << "Daugiausiai uzdirbanti baidare: " <<  endl;
                         print_Canoes(canoes, i );
                        }

        }
}
//------------------------------------------------------------------------------
void popularCanoe      (Canoes&  canoes)
{
    int thebest = 0;

            for (int i = 0; i < canoes.size(); i++)
                    {
                            if (canoes[i].rentedTimes >= thebest)
                                thebest = canoes[i].rentedTimes;
                        }
                for (int i = 0; i < canoes.size(); i++)
        {
            if (canoes[i].rentedTimes == thebest)
                        {
                            cout << "Populiariausia baidare: " <<  endl;
                         print_Canoes(canoes, i );
                        }
        }
}
//------------------------------------------------------------------------------
void print_Customers   (const Customers&  customers, int i)
{
        cout <<"__________________________________________________________________________"
             << endl
             << " "    << (i+1)
             << ". "   << customers[i].name
             << "  "   << customers[i].surename
             << " ("   << customers[i].code <<")"
             << "  "   << customers[i].address
             << "  "   << customers[i].telephone
             << "  "   << customers[i].moneyEarned
             << "  "   << customers[i].timesRented
             << "  "   << customers[i].weight
             << endl
             <<"__________________________________________________________________________"
             << endl;
}
//------------------------------------------------------------------------------
void printCustomers (const Customers& customers)
{
    cout << "Klientu kiekis: " << customers.size() << endl;
    for (int i = 0;  i < customers.size();  i++)
        {
                    print_Customers(customers, i);
                }
}
//------------------------------------------------------------------------------
void addCanoe (Canoes& canoes)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Canoe canoe;
    cout << "Iveskite nauja baidare:" << endl;
    cout << "    Tipas                  : ";  cin >> canoe.model;
    cout << "    Registracijos numeris  : ";  cin >> canoe.regNumber;
    cout << "    pagaminomo metai       : ";  cin >> canoe.year;
    cout << "    Kaina valandai         : ";  cin >> canoe.hourPrice;
    cout << "    Kaina parai            : ";  cin >> canoe.dayPrice;
    cout << "    Maksimalus svoris      : ";  cin >> canoe.maxWeight;
    cout << "    Vietu skaicius         : ";  cin >> canoe.capacity;

    canoe.rentedByCustomer =  0;
    canoe.moneyEarned      =  0;
    canoe.rentedTimes      =  0;
    canoes.push_back(canoe);
}
//------------------------------------------------------------------------------
void addCustomer (Customers& customers)
{
    cin.ignore(INT_MAX, '\n'); // ignoruojam uzsilikusi klaviaturos ENTER
    Customer customer;
    cout << "Iveskite nauja klienta:" << endl;
    cout << "    Vardas             : ";  getline(cin, customer.name);
    cout << "    Pavarde            : ";  getline (cin, customer.surename);
    cout << "    Adresas            : ";  getline (cin, customer.address);
    cout << "    Asmens kodas       : ";  cin >> customer.code;
    cout << "    Telefono numeris   : ";  cin >> customer.telephone;
    cout << "    Jusu svoris        : ";  cin >> customer.weight;

    customer.moneyEarned = 0;
    customer.timesRented = 0;
    customers.push_back(customer);
}
//------------------------------------------------------------------------------
void rentCanoe (Canoes& canoes, Customers& customers)
{
     int canoeNo = 0;
     freeCanoes (canoes);
     cout << "Iveskit baidares eiles numeri: ";
     cin  >> canoeNo;
     if (canoeNo <= 0  ||  canoeNo > canoes.size())
     {
         cout << "KLAIDA: nera baidares su ivestu eiles numeriu.";
         return;
     }
     if (canoes[canoeNo-1].rentedByCustomer != 0)
     {
         cout << "KLAIDA: baidare jau yra isnuomota.";
         return;
     }

     int customerNo = 0;
     printCustomers (customers);
     cout << "Pasirinkite kliento eiles numeri: ";
     cin  >> customerNo;
     if (customerNo <= 0  ||  customerNo > customers.size())
     {
         cout << "KLAIDA: nera kliento su ivestu eiles numeriu.";
         return;
     }
     if (customerNo > canoes[canoeNo-1].maxWeight )
     {
         cout << "KLAIDA: Jus per sunkus sei baidarei.";
         return;
     }

     int dayCount;
     int hourCount;
     string key;
     getline (cin, key);
     cout << " Keliom dienom(prirasykite d) ar valandom(prirasikite h) nuomuosite baidare: ";
     cin >> key;
     if (key=="d")
     {
         cout <<"Kelioms dienoms nuomosite baidare :";
         cin  >> dayCount;
         canoes[canoeNo-1].rentedByCustomer  = customerNo;
         canoes[canoeNo-1].moneyEarned       += dayCount * canoes[canoeNo-1].dayPrice;
                 canoes[canoeNo-1].rentedTimes++;
                 customers[customerNo-1].timesRented++;
         customers[customerNo-1].moneyEarned  += dayCount * canoes[canoeNo-1].dayPrice;

     }
     else if (key=="h")
     {
         cout <<"Kelioms valandoms nuomosite baidare :";
         cin  >>  hourCount;
         canoes[canoeNo-1].rentedByCustomer  = customerNo;
         canoes[canoeNo-1].moneyEarned       += hourCount * canoes[canoeNo-1].hourPrice;
                 canoes[canoeNo-1].rentedTimes++;
             customers[customerNo-1].timesRented++;
         customers[customerNo-1].moneyEarned  += hourCount * canoes[canoeNo-1].hourPrice;
     }
}
//------------------------------------------------------------------------------
void returnCanoe    (Canoes&     canoes)
{
     int canoeNo = 0;
     rentedCanoes (canoes);
     cout << "Iveskit baidares eiles numeri: ";
     cin  >> canoeNo;
     if (canoeNo <= 0  ||  canoeNo > canoes.size())
     {
         cout << "KLAIDA: nera baidares su ivestu eiles numeriu.";
         return;
     }
     canoes[canoeNo-1].rentedByCustomer = 0;
}
//------------------------------------------------------------------------------
void freeCanoes     (Canoes&    canoes)
{
     for (int i = 0;  i < canoes.size();  i++)
    {
         if (canoes[i].rentedByCustomer == 0)
         {
              print_Canoes(canoes, i );
        }
    }
}
//------------------------------------------------------------------------------
void rentedCanoes    (Canoes&    canoes)
{
    for (int i = 0;  i < canoes.size();  i++)
    {
        if (canoes[i].rentedByCustomer != 0)
        {
              print_Canoes(canoes, i );
        }
    }
}
//------------------------------------------------------------------------------
void CustomerRented    (const Canoes& canoes, const Customers& customers)
{
    int CustomerNo = 0;

    for (int i = 0;  i < customers.size();  i++)
    {
            print_Customers (customers, i);
    }
        cout << "Iveskite kliento eiles numeri:";
        cin >> CustomerNo;
        if (CustomerNo <= 0 || CustomerNo > customers.size() )
        {
            cout << "KLAIDA: Tokio kliento su eiles numeriu nera!!!";
                return;
        }

        for (int i = 0; i < canoes.size(); i++)
        {
            if (canoes[i].rentedByCustomer == CustomerNo)
            {

                    print_Canoes(canoes, i );
                }

        }
}
//------------------------------------------------------------------------------
void loadData    (Canoes&    canoes, Customers&   customers)
{
     int canoesCount = 0;
     Canoe canoe;
     ifstream canoesFile;
     canoesFile.open("canoes.txt");
     canoesFile >> canoesCount;
    for (int i = 0;  i < canoesCount;  i++)
    {
       canoesFile  >>canoe.rentedByCustomer
                   >> canoe.maxWeight
                   >> canoe.year
                   >> canoe.hourPrice
                   >> canoe.dayPrice
                   >> canoe.moneyEarned
                   >> canoe.regNumber
                   >> canoe.model
                   >> canoe.capacity
                   >> canoe.rentedTimes;
                   canoes.push_back(canoe);
    }
    canoesFile.close();

     int customersCount = 0;
     Customer customer;
     ifstream customersFile;
     customersFile.open("customers.txt");
     customersFile >> customersCount;
    for (int i = 0;  i < customersCount;  i++)
    {
       customersFile >> customer.name
                     >> customer.surename
                     >> customer.code
                     >> customer.address
                     >> customer.telephone
                     >> customer.moneyEarned
                     >> customer.timesRented
                     >> customer.weight;
       customers.push_back(customer);
    }
    customersFile.close();
}
//=========================================================
void saveData    (Canoes&    canoes, Customers&   customers)
{
     Canoe canoe;
     ofstream canoesFile;
     canoesFile.open("canoes.txt");
     canoesFile << canoes.size() << endl;
     for (int i = 0;  i < canoes.size();  i++)
     {
         canoesFile<< canoes[i].rentedByCustomer << " "
                   << canoes[i].maxWeight        << " "
                   << canoes[i].year             << " "
                   << canoes[i].hourPrice        << " "
                   << canoes[i].dayPrice         << " "
                   << canoes[i].moneyEarned      << " "
                   << canoes[i].regNumber        << " "
                   << canoes[i].model            << " "
                                   << canoes[i].capacity         << " "
                   << canoes[i].rentedTimes      << " "
                                   << endl;
     }
     canoesFile.close();
//**********************************************
     Customer customer;
     ofstream customersFile;
     customersFile.open("customers.txt");
     customersFile << customers.size();
    for (int i = 0;  i < customers.size();  i++)
    {
       customersFile << " "
                         << customers[i].name        << " "
                     << customers[i].surename    << " "
                     << customers[i].code        << " "
                     << customers[i].address     << " "
                     << customers[i].telephone   << " "
                     << customers[i].moneyEarned << " "
                     << customers[i].timesRented << " "
                     << customers[i].weight      << " "
                     << endl;
    }
    customersFile.close();
}
//------------------------------------------------------------------------------

